var assert, eq, f, name, px, qx, rejects, throws;
import * as _ from "@dashkite/joy";
px = {
  equal: eq = function (a, b) {
    return a === b;
  },
  notEqual: _.negate(eq),
  deepEqual: _.equal,
  notDeepEqual: _.negate(_.equal),
  throws: throws = function (f) {
    try {
      f();
    } catch (error1) {
      return true;
    }

    return false;
  },
  doesNotThrow: _.negate(throws)
};
qx = {
  rejects: rejects = async function (f) {
    var error;

    try {
      await f();
    } catch (error1) {
      error = error1;
      return true;
    }

    return false;
  },
  doesNotReject: async function (f) {
    return !(await rejects(f));
  }
};

assert = function (x) {
  let why = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "assertion failed";

  if (x === true) {
    return true;
  } else {
    throw new Error(why);
  }
};

for (name in px) {
  f = px[name];

  (function (name, f) {
    return assert[name] = _.curry(_.arity(f.length, function () {
      for (var _len = arguments.length, ax = new Array(_len), _key = 0; _key < _len; _key++) {
        ax[_key] = arguments[_key];
      }

      return assert(_.apply(f, ax), `assertion ${name} failed`);
    }));
  })(name, f);
}

for (name in qx) {
  f = qx[name];

  (function (name, f) {
    return assert[name] = _.curry(_.arity(f.length, async function () {
      for (var _len2 = arguments.length, ax = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        ax[_key2] = arguments[_key2];
      }

      return assert(await _.apply(f, ax), `assertion ${name} failed`);
    }));
  })(name, f);
}

export default assert;